/* waveGen: a simple wave form generator
 * Implements sine and rectangular wave forms. Wave type is selected by 
 * a command line argument 
 * copyright U. Raich 2017
 * This program is part of the workshop on embedded systems held at 
 * the University of Cape Coast in the winter semester 2017
 * It has been released under the GNU General Public License
 * see gnu.org/licenses/gpl.html
 */

#include <stdio.h>
#include <string.h>
#include "genWave.h"
#include "sendToHW.h"

int main(int argc, char ** argv) {
  unsigned short *wave;
  /* check that the user gave 1 argument */
  if (argc != 2) {
    printf("Usage: %s wave form\n",argv[0]);
    printf(" where wave form is \"sine\" or \"rect\"\n");
    return(-1);
  }
  /* check that the argument is either sine or rect */
  if (!strcmp("sine",argv[1])) {
    printf("# sine wave\n");
    wave=genWave(sine);
  }
  else if (!strcmp("rect",argv[1])) {
    printf("# rectangular wave\n");
    wave=genWave(rect);
  }
  else {
    printf("waveGen: Unknown wave type\n");
  }
  /*
    send the created wave form to the hardware
  */
  if (wave != NULL) 
    sendToDAC(wave,WAVE_FORM_LENGTH);
}
