/*
 * sendToHW.c sends the data created in genWave to the DAC hardware
 * copyright U. Raich 2017
 * This program is part of the workshop on embedded systems held at 
 * the University of Cape Coast in the winter semester 2017
 * It has been released under the GNU General Public License
 * see gnu.org/licenses/gpl.html
 */

#include <stdio.h>
#include "genWave.h"
#include "sendToHW.h"

int strobe(unsigned char dacByte) {
  short tmp = dacByte;
  printf("dacByte: 0x%02x\n", tmp);
  tmp |= DAC_STROBE_MASK;
  printf("DAC_STROBE_MASK: 0x%02x\n", DAC_STROBE_MASK);
  printf("tmp after \"or\" operation: 0x%02x\n",tmp);
  tmp &= ~DAC_STROBE_MASK;
  printf("~DAC_STROBE_MASK: 0x%02x\n", (unsigned char) (~DAC_STROBE_MASK));
  printf("tmp after \"and\" operation: 0x%02x\n", tmp);
  return(DAC_SUCCESS);
}

int sendOneValue(unsigned short dacValue) {
  unsigned char dacByte;
  int i,rw = 0;
  for (i=0;i<3;i++) {
    dacByte = (dacValue >> 4*i) &0xf;
    printf("dacValue for i=%d: 0x%02x\n",i,dacByte);
    dacByte=dacByte | rw << DAC_RW_BIT | i << DAC_RS_BIT;
    printf("dacByte sent to strobe: 0x%02x\n",dacByte);
    strobe(dacByte);
  }
  return(DAC_SUCCESS);
}

int sendToDAC(unsigned short *dacData, int dataSize) {
  unsigned short *dataPtr = dacData;
  int i;
  dataSize =  (dataSize > WAVE_FORM_LENGTH) ? WAVE_FORM_LENGTH : dataSize;
  for (i=0; i<dataSize;i++) {
    printf("--------------- sending dacData[%d]: 0x%03x ---------------\n",
	   i,*dataPtr);
    sendOneValue(*dataPtr++);
  }
  return(DAC_SUCCESS);  
}
