/*
 * include file associated with sendToHW.c which send the data created in 
 * genWave to the DAC hardware
 * copyright U. Raich 2017
 * This program is part of the workshop on embedded systems held at 
 * the University of Cape Coast in the winter semester 2017
 * It has been released under the GNU General Public License
 * see gnu.org/licenses/gpl.html
 */

#ifndef __SEND_TO_HW_H__
#define __SEND_TO_HW_H_
#define DAC_WRITE             0
#define DAC_READ              1
#define DAC_DATA_MASK         0x0f
#define DAC_STROBE_BIT        7
#define DAC_RS_BIT            5
#define DAC_RW_BIT            4
#define DAC_STROBE_MASK       (1 << DAC_STROBE_BIT)
#define DAC_RS_MASK           (3 << DAC_RS_BIT)
#define DAC_RW_MASK           (1 << DAC_RW_BIT)
/* error codes */
#define DAC_SUCCESS 0
/* function prototypes */
int strobe(unsigned char);
int sendOneValue(unsigned short);
int sendToDAC(unsigned short *,int);
#endif
